
#include "unix.h"
#include "x.h"
#include "xt.h"
#include "objects.h"
#include "externs.h"


void
map_dialog(dialog, xpos, ypos)
Widget dialog;
Position *xpos, *ypos;
{
    Position x, y;
    Dimension w, h;
    Dimension width, height, border_width;
    Dimension rWidth, rHeight;
    int rx, ry, wx, wy;
    unsigned int mask;
    Window root, child;
    extern Widget toplevel;

    /*
     * This will position the upper left hand corner of the popup at the
     * center of the widget which invoked this callback, which will also
     * become the parent of the popup.  I don't deal with the possibility
     * that the popup will be all or partially off the edge of the screen.
     */
    XQueryPointer( XtDisplay( toplevel ), XtWindow( toplevel ),
                   &root, &child,
                   &rx, &ry, &wx, &wy, &mask );
    XtVaGetValues( toplevel,
                   XtNwidth, &width,
                   XtNheight, &height,
                   XtNborderWidth, &border_width,
                   NULL );
    width  += border_width + border_width;
    height += border_width + border_width;
    x = rx - wx + width / 2;
    y = ry - wy + height / 2;
    rWidth = WidthOfScreen( XtScreen( toplevel ) );
    rHeight = HeightOfScreen( XtScreen( toplevel ) );
    if( (int)(x + width) > (int)rWidth ) x = rWidth - width;
    if( (int)(y + height) > (int)rHeight ) y = rHeight - height;
    if( x < 0 ) x = 0;
    if( y < 0 ) y = 0;
    *xpos = x;
    *ypos = y;
}
