
#ifndef _global_h
#define _global_h

typedef struct _Vertex {
    float x, y, z;
} Vertex;

typedef Vertex Vector;

typedef struct _Edge {
    int e;
} Edge;

typedef struct _Facet {
    int count;
    Edge *edges;
} Facet;

typedef struct _material_predef {
    PEXColorRGB ambientColor;
    PEXColorRGB diffuseColor;
    PEXColorRGB specularColor;
    float       shininess;
    float       transparency;
    float       shininess_conc;
} material_predef;

typedef struct _movie *Movie;

struct _movie {
#ifdef PIX_FRAME
    Pixmap frame;
#else
    XImage *frame;
#endif
    Movie next;
    Movie prev;
};

#endif /* _global_h */

